//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_minimum 0
#property indicator_maximum 100

//---- input parameters
extern int ExtRsiPeriod=14;
extern int ExtDpoPeriod=14;
//---- buffers
double ExtRsiBuffer[];
double ExtDpoBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string sShortName;
   IndicatorBuffers(2);
   SetIndexBuffer(0,ExtRsiBuffer);
   SetIndexBuffer(1,ExtDpoBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
//---- name for DataWindow and indicator subwindow label
   sShortName="RSI of DPO("+ExtRsiPeriod+","+ExtDpoPeriod+")";
   IndicatorShortName(sShortName);
   SetIndexLabel(0,sShortName);
//---- first values aren't drawn
//----
   return(0);
  }
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
  {
   int i,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   double t_prd = ExtDpoPeriod/2.0+1.0;
   for(i=limit; i>=0; i--) ExtDpoBuffer[i]=Close[i] - iMA(NULL, 0, ExtDpoPeriod, t_prd, MODE_SMA, PRICE_CLOSE, i);
   for(i=limit; i>=0; i--) ExtRsiBuffer[i]=iRSIOnArray(ExtDpoBuffer,0,ExtRsiPeriod,i);
   return(0);
}

